/*
    QuickMSG
    Copyright (C) 2014  Jeroen Vreeken <jeroen@vreeken.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef _INCLUDE_ATTACHMENT_H_
#define _INCLUDE_ATTACHMENT_H_

#include <stdlib.h>

struct attachment {
	void *data;
	size_t length;
	char *basetype;
	char *type;
	char *name;
};

struct attachment *attachment_alloc(void);
void attachment_free(struct attachment *a);

int attachment_data_set(struct attachment *a, const void *data, const size_t length);
int attachment_type_set(struct attachment *a, const char *type);
int attachment_basetype_set(struct attachment *a, const char *type);
int attachment_name_set(struct attachment *a, const char *name);

struct attachment_list {
	struct attachment **attachments;
	size_t size;
};

struct attachment_list *attachment_list_alloc(void);
void attachment_list_free(struct attachment_list *l);

int attachment_list_add(struct attachment_list *l, struct attachment *a);
struct attachment *attachment_list_remove(struct attachment_list *l, size_t c);

#endif /* _INCLUDE_ATTACHMENT_H_ */
